# es6-load-script-sync
> Dynamically loading JavaScript synchronously

## Installation

```bash
npm install --save-dev @thinkeloquent/es6-load-script-sync
```
##### Node Packaged Modules (https://www.npmjs.com/package/@thinkeloquent/es6-load-script-sync)

### Usage
##### Adding `@thinkeloquent/es6-load-script-sync` to an existing Karma config

```js
const loadScriptSync = require('@thinkeloquent/es6-load-script-sync');
loadScriptSync.doc.safeToWrite(/* <REGEX_01>, <REGEX_02...> */);
loadScriptSync.doc.script(/* <JavaScript_File_URL,...> */);
```

### Examples

##### External JavaScript File `./vendor.js`

```js
const loadScriptSync = require('@thinkeloquent/es6-load-script-sync');
loadScriptSync.doc.safeToWrite('code.jquery.com', /(angularjs)/g);
loadScriptSync.doc.script(
  'https://code.jquery.com/jquery-3.1.1.min.js',
  'https://ajax.googleapis.com/ajax/libs/angularjs/1.5.6/angular.min.js'
);
```

##### Inline HTML

```html
<!doctype html>
<html ng-app>
  <head>
    <title>My Angular App</title>
    <script src="./vendor.js"></script>
  </head>
  <body>
  </body>
</html>
```

### Resources

- [CSP - content security policy](https://www.html5rocks.com/en/tutorials/security/content-security-policy/)

### Authors

  - [Think Eloquent](https://github.com/thinkeloquent)

## License

(The MIT License)

Copyright (c) 2014 Carlos Marte &lt;opensource@carlosmarte.me&gt;

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
'Software'), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

##### This file was generated on November 20 2016.
