'use strict'

const gulp = require('gulp');
const webpack = require('webpack');
const gutil = require('gulp-util');
const path = require('path');
const clean = require('gulp-clean');

const packageName = 'es6-load-script-sync';
const bases = {
 app: 'src/',
 dist: 'dist/',
};


gulp.task('default', ['webpack'], () => { });

gulp.task('webpack', ['clean'], function(callback) {
  webpack({
    entry: {
      [packageName]: './src/document-write.js',
      'example/document-write': './src/document-write.example.js',
      [`${packageName}.promise`]: ['core-js/es6/promise', './src/document-write.js'],
  	},
    output: {
  		filename: './dist/scripts/[name].js',
  	},
    module: {
      loaders: [
        { test: /\.js$/, exclude: /node_modules/, loader: 'babel-loader' }
      ]
    },

  }, function(error, stats) {
    if(error) {
      throw new gutil.PluginError('webpack', error);
    }
    gutil.log('[webpack]', stats.toString({ }));
    callback();
  });
});

gulp.task('clean', function() {
  return gulp.src(bases.dist)
    .pipe(clean());
});

gulp.task('lint', function() {
  return gulp.src('./src/**.*.js')
    .pipe(jshint())
    .pipe(jshint.reporter('default'))
});

gulp.task('watch', function() {
  gulp.watch('src/**/*', ['webpack']);
});
