'use strict';

const scriptLoader = require('./script-loader');

const write = document.write;
let safeToWrite;

function deprecated(message) {
  const caption = 'This feature is deprecated: ';
  const args = Array.prototype.slice.call(arguments);
  const isRegexDefined = typeof(safeToWrite) !== 'undefined' && safeToWrite.test;
  const doesRegexPass = safeToWrite.test(args[1]);

  if(isRegexDefined && doesRegexPass) {
    write.call(document, args[1]);
  }
  
  if(isRegexDefined === false && doesRegexPass === false && console && console.error) {
    console.error(caption + message, [
      typeof(safeToWrite) !== 'undefined',
      safeToWrite.test(args[1]),
      arguments
    ]);
  }
}

document.write = deprecated.bind(null, 'document.write');
document.writeln = deprecated.bind(null, 'document.writeln');

module.exports = {
  write: function() {
    const args = Array.prototype.slice.call(arguments);
    return write.apply(document, args);
  },
  script: scriptLoader(write),
  safeToWrite: function(regex) {
    const args = Array.prototype.slice.call(arguments);
    safeToWrite = new RegExp(`(${args.join('|')})`, 'g');
  }
}
