'use strict';

module.exports = function(write) {
  function ScriptLoader() {
    const args = Array.prototype.slice.call(arguments);
    const open = '\x3Cscript';
    const close = '\x3E \x3C/script\x3E';
    const len = args.length;
    return new Promise(function(resolve, reject) {
      const startTime = (new Date()).getTime();
      try {
        for (let i = 0; i < len; i++) {
          write.call(document, `${open} src="${args[i]}" ${close}`);
        }
      } catch (error) {
        reject(error);
        return;
      }
      const stopTime = (new Date()).getTime();
      resolve(stopTime - startTime);
    });
  }
  return ScriptLoader;
};
